/* MD5.H - header file for MD5C.C
 */

/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
   rights reserved.

   License to copy and use this software is granted provided that it
   is identified as the "RSA Data Security, Inc. MD5 Message-Digest
   Algorithm" in all material mentioning or referencing this software
   or this function.

   License is also granted to make and use derivative works provided
   that such works are identified as "derived from the RSA Data
   Security, Inc. MD5 Message-Digest Algorithm" in all material
   mentioning or referencing the derived work.  
                                                                    
   RSA Data Security, Inc. makes no representations concerning either
   the merchantability of this software or the suitability of this
   software for any particular purpose. It is provided "as is"
   without express or implied warranty of any kind.  
                                                                    
   These notices must be retained in any copies of any part of this
   documentation and/or software.  
 */

#ifndef MD5_H
#define MD5_H

#include "hashcom.h"

#ifndef MD5_SMALL
  #define MD5_SMALL 0 /* low footprint md5 */
#endif

#define MD5_DIGEST_SIZE   16

typedef struct {
  uns32 state[4];        /* state (ABCD) */
  uns32 count[2];        /* number of bits, modulo 2^64 (lsb first) */
  uns8 buffer[64];       /* input buffer */
} md5_context;

#ifdef __cplusplus
extern "C" {
#endif

#ifdef WIN32
 #ifdef CRYPTO_EXPORTS
   #define extern   extern __declspec(dllexport)
 #else
   #define extern   extern __declspec(dllimport)
 #endif
#endif

extern void md5_init(md5_context *context);
extern void md5_update(md5_context *context, uns8 *input, uns32 inputLen);
extern void md5_final(uns8 *digest, md5_context *context);

#ifdef __cplusplus
}
#endif

#ifdef WIN32
  #undef extern
#endif

/*
md5(abc) = 900150983cd24fb0d6963f7d28e17f72
*/

#endif
